// Lisäys käyttäen documentclientia
const { PutCommand } = require('@aws-sdk/lib-dynamodb');
const { ddbcli, doccli } = require('./ddbconn');

/* Lisätään opiskelija. Tietotyyppien ei tarvitse olla mukana, koska
   documentclient huolehtii niistä.

   Huomaa, että käytämme name-attribuutin 
   sijasta studentname-attribuuttia, koska name on varattu sana DDB:ssä.
*/
const params = {
  TableName: 'Students',
  Item: {
    studentcode: 'e1234',
    studentname: 'Esti Opiskelija',
    email: 'e1234@jamk.fi',
    studypoints: 0,
    grades: [
      {
        coursecode: 'HTS10600',
        grade: 0,
      },
    ],
  },
};

const addStudent = async () => {
  try {
    const data = await doccli.send(new PutCommand(params));
    console.log('Success, student created', data);
    return data;
  } catch (err) {
    console.error(err);
  }
};

addStudent();
