// Lisäys ilman documentclientia
const { PutItemCommand } = require('@aws-sdk/client-dynamodb');
const { ddbcli, doccli } = require('./ddbconn');

/* Lisätään opiskelija. Koska lisättävän tiedon tyyppien pitää
   olla mukana, näyttää tämä hieman monimutkaiselta.

   Huomaa, että käytämme name-attribuutin sijasta studentname-
   attribuuttia, koska name on varattu sana DDB:ssä.
*/
const params = {
  TableName: 'Students',
  Item: {
    studentcode: { S: 'o1234' },
    studentname: { S: 'Ossi Opiskelija' },
    email: { S: 'o1234@jamk.fi' },
    studypoints: { N: '0' },
    grades: {
      L: [
        {
          M: {
            coursecode: { S: 'HTS10600' },
            grade: { N: '0' },
          },
        },
      ],
    },
  },
};

const addStudent = async () => {
  try {
    const data = await ddbcli.send(new PutItemCommand(params));
    console.log('Success, student created', data);
    return data;
  } catch (err) {
    console.error(err);
  }
};

addStudent();
