/*

Luodaan DDB-taulu Students, johon olisi tarkoitus laittaa tämän näköistä
dataa:

{
  studentcode: 't1234',
  studentname: 'Testi Opiskelija',
  email: 't1234@jamk.fi',
  studypoints: 0,
  grades: [
    {
      coursecode: 'HTS10600',
      grade: 0,
    },
  ],
}

Huomaa, että emme tee tässä itemille erillistä id:tä, vaan käytämme
primary keynä studentcodea, jonka uniikkina sopii siihen hyvin.

*/
const { CreateTableCommand } = require('@aws-sdk/client-dynamodb');
// Haetaan ddb-yhteysolio
const { ddbcli, doccli } = require('./ddbconn');

const params = {
  // primary key sisältää tässä vain partition keyn joka on studentcode
  AttributeDefinitions: [
    {
      AttributeName: 'studentcode',
      AttributeType: 'S',
    },
  ],
  KeySchema: [
    {
      AttributeName: 'studentcode',
      KeyType: 'HASH',
    },
  ],
  ProvisionedThroughput: {
    ReadCapacityUnits: 1,
    WriteCapacityUnits: 1,
  },
  TableName: 'Students',
};

async function createTable() {
  try {
    const data = await ddbcli.send(new CreateTableCommand(params));
    console.log('Success, table created', data);
    return data;
  } catch (err) {
      console.log('Error', err);
    }
}

createTable();
