/* Haetaan opiskelijat joilla on alle 5 opintopistettä PartiQL-kyselykielellä

PartiQL:ää käytettäessä ExecuteStatementCommand palauttaa kyselyn tuloksen
DynamoDB-muodossa, eikä muuta sitä JS-oliomuotoon. Tällöin tulos pitää
muuttaa JS-olioksi unmarshall-metodin avulla, mikä on tässä kommenteissa.
*/

const { ExecuteStatementCommand } = require('@aws-sdk/client-dynamodb');
//const { unmarshall } = require('@aws-sdk/util-dynamodb');
const { ddbcli, doccli } = require('./ddbconn');

const tableName = 'Students';
const spoints = 5;

const params = { // huomaa vinohipsut kun käytetään JS:n templaattisyntaksia
  Statement: `SELECT * FROM ${tableName} where studypoints < ${spoints}`,
  // Muuttujia voidaan sijoittaa SQL-lauseeseen myös alla olevalla tavalla.
  // Muuttujan paikalle SQL-lauseeseen tulee tällöin ?
  // Parameters: [{ N: '5' }],
};

const getBelowLimit = async () => {
  try {
    const data = await doccli.send(new ExecuteStatementCommand(params));
    console.log(data.Items);
    /*
    data.Items.forEach((item) => {
      console.log(unmarshall(item));
    });
    */
    return data;
  } catch (err) {
    console.error(err);
  }
};

getBelowLimit();
