const { UpdateCommand } = require('@aws-sdk/lib-dynamodb');
const { ddbcli, doccli } = require('./ddbconn');

/* Päivitetään tietyn opiskelijan tietyn kurssin(grades) arvosanaa.
   Oletamme, että saamme graden indeksin käyttöliittymästä
   reittiparametrina.
   

   Jos pitäisi kehitellä expression-lause, jolla valitaan
   kurssi sen tunnuksen perusteella, niin se ei lähteiden 
   perusteella onnistu, jos mapit ovat listin sisällä. 
   Jos Itemin rakenteen muuttaa siten, että mapit ovat mapin 
   sisällä, niin homma onnistuu:
   https://stackoverflow.com/questions/51911927/update-nested-map-dynamodb 
*/

// graden indeksi saadaan Lambda-funktiossa eventin reittiparametrina
const gindex = 0;
// grade saadaan Lambda-funktiossa eventin bodysta
const grade = 3;

const params = {
  TableName: 'Students',
  Key: {
    studentcode: 't1234',
  },
  // päivityslause jos mapit ovat listin sisällä
  UpdateExpression: `set grades[${gindex}].grade = :gr`,

  // päivityslause jos käytetään mappeja mapin sisällä
  // UpdateExpression: 'set #gs.#cc.grade = :gr',

  ExpressionAttributeValues: {
    ':gr': grade,
  },
  // näitä tarvitaan jos käytetään mappeja mapin sisällä 
  /*
  ExpressionAttributeNames: {
    '#gs': 'grades',
    '#cc': 'HTS10600'
  },
  */
};

const updateGrade = async () => {
  try {
    const data = await doccli.send(new UpdateCommand(params));
    console.log('Success, grade updated', data);
  } catch (err) {
    console.log('Error', err);
  }
};

updateGrade();
