const { UpdateCommand } = require('@aws-sdk/lib-dynamodb');
const { ddbcli, doccli } = require('./ddbconn');

/* Päivitetään opiskelijan opintopisteet arvoon 10.
   DynamoDB:n "kyselyjä" kutsutaan nimellä expression
   https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/Expressions.html
*/
const params = {
  TableName: 'Students',
  Key: {
    'studentcode': 't1234',
  },
  // päivityslause
  UpdateExpression: 'set studypoints = :sp',
  // päivitetään arvoon 10
  ExpressionAttributeValues: {
    ':sp': 10,
  
  },
};

const updateStudypoints = async () => {
  try {
    const data = await doccli.send(new UpdateCommand(params));
    console.log('Success, studypoints updated', data);
  } catch (err) {
    console.log('Error', err);
  }
};

updateStudypoints();
