// grade-mapin lisäys grades-listaan eli upsert.
// samalla lisätään opintopisteitä, jos arvosana on > 0

const { UpdateCommand } = require('@aws-sdk/lib-dynamodb');
const { ddbcli, doccli } = require('./ddbconn');

// Tämä saadaan Lambda-funktiossa eventin reittiparametrina
const scode = 't1234';
// Nämä kaksi saadaan Lambda-funktiossa eventin bodystä
const ccode = 'HTS10800';
const sgrade = 5;
// Opintopisteisiin lisäys vain jos arvosana > 0
let inc = 0;
if (sgrade > 0) {
  inc = 5;
}

// Upsert tehdään list_append()-metodilla
const params = {
  TableName: 'Students',
  Key: {
    studentcode: scode,
  },
  // päivityslause
  UpdateExpression:
    'set grades = list_append(grades, :vals) add studypoints :inc',
  // listaan upsertattava data, huomaa hakasulut olion ympärillä
  ExpressionAttributeValues: {
    ':vals': [{ coursecode: ccode, grade: sgrade }],
    ':inc': inc,
  },
  // paluuarvona voidaan vastaanottaa päivitetty grades-lista
  ReturnValues: 'UPDATED_NEW',
};

const upsertGrade = async () => {
  try {
    const data = await doccli.send(new UpdateCommand(params));
    console.log('Success, grade added', data);
    return data;
  } catch (err) {
    console.error(err);
  }
};

upsertGrade();
